From 2a0d657eded51651a8aec658a4c84a607ad51988 Mon Sep 17 00:00:00 2001
From: Helmut Grohne <helmut@subdivi.de>
Date: Mon, 9 Nov 2015 22:20:57 +0100
Subject: [PATCH 3/3] inhibit chroot when --force-remote-scripts

---
 src/script.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

diff --git a/src/script.c b/src/script.c
index ac79444..00075b9 100644
--- a/src/script.c
+++ b/src/script.c
@@ -99,7 +99,7 @@ maintscript_pre_exec(struct command *cmd)
 	const char *admindir = dpkg_db_get_dir();
 	size_t instdirl = strlen(instdir);
 
-	if (*instdir) {
+	if (*instdir && !fc_remote_scripts) {
 		if (strncmp(admindir, instdir, instdirl) != 0)
 			ohshit(_("admindir must be inside instdir for dpkg to work properly"));
 		if (setenv("DPKG_ADMINDIR", admindir + instdirl, 1) < 0)
@@ -112,8 +112,8 @@ maintscript_pre_exec(struct command *cmd)
 	}
 	/* Switch to a known good directory to give the maintainer script
 	 * a saner environment, also needed after the chroot(). */
-	if (chdir("/"))
-		ohshite(_("failed to chdir to '%.255s'"), "/");
+	if (chdir(fc_remote_scripts ? instdir : "/"))
+		ohshite(_("failed to chdir to '%.255s'"), fc_remote_scripts ? instdir : "/");
 	if (debug_has_flag(dbg_scripts)) {
 		struct varbuf args = VARBUF_INIT;
 		const char **argv = cmd->argv;
@@ -127,7 +127,7 @@ maintscript_pre_exec(struct command *cmd)
 		      args.buf);
 		varbuf_destroy(&args);
 	}
-	if (!instdirl)
+	if (fc_remote_scripts || !instdirl)
 		return cmd->filename;
 
 	assert(strlen(cmd->filename) >= instdirl);
-- 
2.4.6

